/*
mCombo.cc
Created by Jean-Pierre Martel in June 2000

Description: a custom Combobox control able to do
incremential search on an INDEXED UPPER field.

Needed files: Peter Rorlick's zSeeker.cc
   mC_UpArrow.gif
   mC_DnArrow.gif

This custom control only works on a form whose query is
set on an indexed upper field.

The author accepts no responsibility for the use or consequences 
of the use of this software.
*/

class mCombo(parentObj, name) of CONTAINER(parentObj, name) custom
   with (this)
      set procedure to zSeeker.cc additive
      * set procedure to Seeker.cc additive
      onOpen = class::CONTAINER1_ONOPEN
      onDesignOpen = {; this.borderStyle = 0;this.grid1.height=6;this.height=33}
      parent.metric := 6 // Pixels
      visible = false
      borderStyle = 3 // None
      left = 9
      top = 8
      width = 305
      height = 27
   endwith

   this.SEEKER1 = new zSEEKER(this)
   * this.SEEKER1 = new SEEKER(this)
   with (this.SEEKER1)
      onGotFocus = class::SEEKER1_ONGOTFOCUS
      height = 22
      left = 0
      top = 0
      width = 300
      value = ""
      pageno = 0
   endwith

   this.IMAGE2 = new IMAGE(this)
   with (this.IMAGE2)
      onLeftMouseDown = class::IMAGE_ONLEFTMOUSEDOWN
      onLeftMouseUp = class::CLOSE_COMBOBOX
      height = 18
      left = 281
      top = 2
      width = 17
      dataSource = 'FILENAME "mC_UpArrow.gif"'
      alignment = 4	// True Size
      pageno = 0
      borderStyle = 3	// None
   endwith

   this.IMAGE1 = new IMAGE(this)
   with (this.IMAGE1)
      onLeftMouseDown = class::IMAGE_ONLEFTMOUSEDOWN
      onLeftMouseUp = class::OPEN_COMBOBOX
      height = 18
      left = 281
      top = 2
      width = 17
      dataSource = 'FILENAME "mC_DnArrow.gif"'
      alignment = 4	// True Size
      pageno = 0
      borderStyle = 3	// None
   endwith

   this.GRID1 = new GRID(this)
   with (this.GRID1)
      onGotFocus = class::GRID1_ONGOTFOCUS
      onLostFocus = class::GRID1_ONLOSTFOCUS
      onSelChange = class::GRID1_ONSELCHANGE
      onLeftMouseDown = class::CLOSE_COMBOBOX
      mousePointer = 13 // Hand  the grid doesn't have such a property for now
      bgColor = "0XE9E9E9"
      cellHeight = 18
      hasIndicator = false
      hasColumnHeadings = false
      rowSelect = true
      pageno = 0
      height = 97
      left = 0
      top = 22
      width = 300
   endwith

	Function Grid1_onSelChange
      this.parent.seeker1.value = this.parent.parent.rowset.fields[this.parent.parent.rowset.indexName].value
      this.parent.seeker1.keyboard("{End}")
      return

   Function Container1_onOpen
      this.rowsShown = 4
      this.Grid1.dataLink = this.parent.rowset
      this.parent.rowset.first()
      class::Resize_all()
		this.visible = true
      return

 	Function Resize_all
      local d, s
      d = set( "decimals" )
      s = this.Seeker1
      set decimals to 0
      // Floor() because the value of MaxHeight is expressed in pixels (it can't have decimals)
      this.MaxHeight = floor((this.rowsShown * (this.grid1.cellHeight + 1)) + s.top + s.height + 21)
      set decimals to d
      this.height = s.height  //  because any save under the Form Designer will change its default value
      this.MinHeight = this.height
   with(this)
   	borderStyle = 3 //  because any save under the Form Designer will will change its default value
      width = s.width + s.left + 5
      Image1.height = s.height - 4
      Image1.left = s.left + s.width - 19
      Image1.width = 17
      Image1.top = s.top + 2
      Image2.height = s.height - 4
      Image2.left = s.left + s.width - 19
      Image2.width = 17
      Image2.top = s.top + 2
      Grid1.top = s.height
      Grid1.width = s.width
      Grid1.height = this.MaxHeight - s.height
   endwith
   return

   Function Seeker1_onGotFocus
      class::Open_Combobox()  // equivalent to autoDrop = true
      Seeker::OnGotFocus()      // to run the code in the base Seeker class
      return

   Function Image_onLeftMouseDown(flags, col, row)
      this.borderStyle = 2 // Lowered
      return

   Function Open_Combobox
      p = this.parent
      p.Image1.left = -300
      p.Image1.borderStyle = 3 // None
      p.height = p.MaxHeight
      p.Image2.left = p.width - 24
      p.seeker1.setFocus()
   return

   Function Close_Combobox
      p = this.parent
      p.Image2.left = -300
      p.Image2.borderStyle = 3 // None
      p.height = p.MinHeight
      p.Image1.left = p.width - 24
   return

   Function Grid1_onGotFocus
      this.bgColor = "White"
      this.oCUAEnter = set ( "CUAEnter" )
      set CUAEnter off   // because Enter would move to next column otherwise
      return

   Function Grid1_onLostFocus
      this.bgColor = "0xe9e9e9"
      x = this.oCUAEnter
      set CUAEnter &x.
      return

endclass
